#include <conio.h>
#include <stdio.h>


int main()
{
        int n; // the number of vertices (/the number of lines in an input file)
        int N; // the number of edges
        int i,j,l;
        char ostatni = 0, suma = 0, max, T[50]; // T - partition
        int C[75]; // created of vector T (information on the kind of an edge)
        int il_p=0; // the number of elements of partition
        int P[75]; // permutations
        int Z[75]; // used elements of permutations
        int V[12]; // used vertices as ends of paths
        int po; // position in a permutation
        int K[150][2]; // matrix of edges (two vertices)
        int A[75]; // the choice of directed edges out of K
        FILE *graph; // investigated graph
        FILE *outcome; // outcome: counterexample or all the realizations
        char znak; // to read the datas from an input files
        int li_pa=0; // the number of admissible partitions
        int n_arity_2;


//******************** Input information (graph G) ******************
//1 line: the number of lines with information; subsequent lines: a vertex x: a neighbour of x,...,a neighbour of x.
//in the last information line: "0."  at the end if the graph is of even order or "-1." oterwise; under it: the number of vertices of G.

        if ((graph=fopen("G.txt","r")) == NULL) printf("I cannot open an input file.");
        else
          {fscanf(graph,"%d",&n);
           l=0;
           for (i=1;i<=n;i++)
              {fscanf(graph,"%d",&N);
               fscanf(graph,"%c",&znak);
               fscanf(graph,"%c",&znak);
               while (znak != '.')
                    {fscanf(graph,"%d",&j);
                     fscanf(graph,"%c",&znak);
                     if (j > 0)
                       {l++;
                        K[l][1]=N;
                        K[l][2]=j;
                       }
                     else n_arity_2 = -1*j;
                    }
              }
           N=l;
           fscanf(graph,"%d",&n);
           fclose(graph);
          }
//******************************************************************

        // filling in the reverse order of edges.
        for (i=1;i<=N;i++)
           {
            K[N+i][1]=K[i][2];
            K[N+i][2]=K[i][1];
           }

//*************************************************************************
//********* Initialization of the main function: ******************************
        clrscr();
        T[1]=1;
        po=1;

        if ((outcome=fopen("Greal.txt","w")) == NULL) printf("I cannot open an outcome file.");
        else
          {fprintf(outcome,"Here we have packings (vertices, we have to subseqently traverse, starting from the begining of each short sequence each time; note that each time, the end of the closed trail is distinct) of all admissible (for vertex-distinguishing edge-coloring, see the paper: Vertex-distinguishing edge-colorings of sums of paths) sequences (partitions) of orders of paths for a given graph on %d vertices and with %d following edges: ",n,N);
           for (i=1;i<N;i++) fprintf(outcome,"(%d,%d), ",K[i][1],K[i][2]);
           fprintf(outcome,"(%d,%d):\n",K[N][1],K[N][2]);
          }
        
        while (il_p >= 0)
             {if ( T[il_p] > ostatni +1 ) max = T[il_p];
              else max = ostatni +1;

              if ( N - suma >= max )
                {   il_p++;
                    T[il_p]=max;
                    suma=suma+T[il_p];
                    if (( ((suma <= N-il_p)&&(n_arity_2 == 1))||((n_arity_2 == 0)&&(suma <= N-n/2+il_p)) )&&(2*il_p<=n))
                      {// here we obtain a subsequent partition:
                       printf("\nSearching for a packing of the sequence:  ");
                       for ( i = 1; i < il_p; i++ ) printf("%d,",T[i]+1);
                       printf("%d:",T[i]+1);
                       li_pa++;

//****************************************************************
//****************************************************************
//************** SEARCHING FOR A REALIZATION *********************
//****************************************************************

        l=1;
        for (i=1;i<=il_p;i++)
           {if (T[i] == 1)
              {C[l]=4;
               l++;
              }
            else
              {C[l]=1;
               l++;
               if (T[i] == 2)
                 {C[l]=5;
                  l++;
                 }
               else
                 {C[l]=2;
                  l++;
                  for (j=3;j<=T[i]-1;j++)
                     {C[l]=0;
                      l++;
                     }
                  C[l]=3;
                  l++;
                 }
              }
           }

        for (i=1;i<=N;i++)
           {Z[i]=0;
           }
        P[0]=0;
        P[1]=1;
        Z[N+1]=1;
        po=1;

        for (i=1; i<=n; i++) V[i]=0;

        while (po>0)
             {if (Z[P[po]] == 1)
                {if (P[po]<N) {P[po]=P[po]+1;}
                 else
                   {po--;
                    Z[P[po]]=0;
                    if ((C[po] == 1)||(C[po] == 4)) V[K[A[po]][1]]=0;
                    if ((C[po] == 3)||(C[po] == 4)||(C[po] == 5)) V[K[A[po]][2]]=0;
                    P[po]=P[po]+1;
                   }
                }
              else
                {switch (C[po])
                       {case 0: if (K[A[po-1]][2] == K[P[po]][1])
                                  {A[po]=P[po];
                                   Z[P[po]]=1;
                                   po++;
                                   P[po]=1;
                                  }
                                else
                                  {if (K[A[po-1]][2] == K[P[po]][2])
                                     {A[po]=P[po]+N;
                                      Z[P[po]]=1;
                                      po++;
                                      P[po]=1;
                                     }
                                   else
                                     {if (P[po] == N)
                                        {po--;
                                         Z[P[po]]=0;
                                        }
                                      P[po]=P[po]+1;
                                     }
                                  }
                                break;

                        case 4: if ((V[K[P[po]][1]] == 0)&&(K[P[po]][1] != K[P[po]][2])&&(V[K[P[po]][2]] == 0))
                                  {A[po]=P[po];
                                   V[K[A[po]][1]] = 1;
                                   V[K[A[po]][2]] = 1;
                                   Z[P[po]]=1;
                                   po++;
                                   P[po]=1;
                                  }
                                else
                                  {if (P[po] == N)
                                     {po--;
                                      Z[P[po]]=0;
                                      if ((C[po] == 1)||(C[po] == 4)) V[K[A[po]][1]]=0;
                                      if ((C[po] == 3)||(C[po] == 4)||(C[po] == 5)) V[K[A[po]][2]]=0;
                                     }
                                   P[po]=P[po]+1;
                                  }
                                break;                                

                        case 1: if (V[K[P[po]][1]] == 0)
                                  {A[po]=P[po];
                                   V[K[A[po]][1]] = 1;
                                   Z[P[po]]=1;
                                   po++;
                                   P[po]=1;
                                  }
                                else
                                  {if (V[K[P[po]][2]] == 0)
                                     {A[po]=P[po]+N;
                                      V[K[A[po]][1]] = 1;
                                      Z[P[po]]=1;
                                      po++;
                                      P[po]=1;
                                     }
                                   else
                                     {if (P[po] == N)
                                        {po--;
                                         Z[P[po]]=0;
                                         if ((C[po] == 1)||(C[po] == 4)) V[K[A[po]][1]]=0;
                                         if ((C[po] == 3)||(C[po] == 4)||(C[po] == 5)) V[K[A[po]][2]]=0;
                                        }
                                      P[po]=P[po]+1;
                                     }
                                  }
                                break;
                                
                        case 2: if (K[P[po]][1] == K[A[po-1]][2])
                                  {A[po]=P[po];
                                   Z[P[po]]=1;
                                   po++;
                                   P[po]=1;
                                  }
                                else
                                  {if ((K[P[po]][1] == K[A[po-1]][1])&&(V[K[A[po-1]][2]] == 0))
                                     {A[po]=P[po];
                                      V[K[A[po-1]][1]]=0;
                                      if (A[po-1] <= N) A[po-1] = A[po-1]+N;
                                      else A[po-1] = A[po-1]-N;
                                      V[K[A[po-1]][1]]=1;
                                      Z[P[po]]=1;
                                      po++;
                                      P[po]=1;
                                     }
                                   else
                                     {if (K[P[po]][2] == K[A[po-1]][2])
                                        {A[po]=P[po]+N;
                                         Z[P[po]]=1;
                                         po++;
                                         P[po]=1;
                                        }
                                      else
                                        {if ((K[P[po]][2] == K[A[po-1]][1])&&(V[K[A[po-1]][2]] == 0))
                                           {A[po]=P[po]+N;
                                            V[K[A[po-1]][1]]=0;
                                            if (A[po-1] <= N) A[po-1] = A[po-1]+N;
                                            else A[po-1] = A[po-1]-N;
                                            V[K[A[po-1]][1]]=1;
                                            Z[P[po]]=1;
                                            po++;
                                            P[po]=1;
                                           }
                                         else
                                           {if (P[po] == N)
                                              {po--;
                                               Z[P[po]]=0;
                                               if ((C[po] == 1)||(C[po] == 4)) V[K[A[po]][1]]=0;
                                               if ((C[po] == 3)||(C[po] == 4)||(C[po] == 5)) V[K[A[po]][2]]=0;
                                              }
                                            P[po]=P[po]+1;
                                           }
                                        }
                                     }
                                  }
                                break;

                        case 3: if ((K[P[po]][1] == K[A[po-1]][2])&&(V[K[P[po]][2]] == 0))
                                  {A[po]=P[po];
                                   V[K[A[po]][2]] = 1;
                                   Z[P[po]]=1;
                                   po++;
                                   P[po]=1;
                                  }
                                else
                                  {if ((K[P[po]][2] == K[A[po-1]][2])&&(V[K[P[po]][1]] == 0))
                                     {A[po]=P[po]+N;
                                      V[K[A[po]][2]] = 1;
                                      Z[P[po]]=1;
                                      po++;
                                      P[po]=1;
                                     }
                                   else
                                     {
                                     if (P[po] == N)
                                        {po--;
                                         Z[P[po]]=0;
                                         if ((C[po] == 1)||(C[po] == 4)) V[K[A[po]][1]]=0;
                                         if ((C[po] == 3)||(C[po] == 4)||(C[po] == 5)) V[K[A[po]][2]]=0;
                                        }
                                      P[po]=P[po]+1;
                                     }
                                  }
                                break;   

                        default:
                                if ((K[P[po]][1] == K[A[po-1]][2])&&(V[K[P[po]][2]] == 0))
                                  {V[K[P[po]][2]] = 1;
                                   A[po]=P[po];
                                   Z[P[po]]=1;
                                   po++;
                                   P[po]=1;
                                  }
                                else
                                  {if ((K[P[po]][1] == K[A[po-1]][1])&&(V[K[A[po-1]][2]] == 0)&&(V[K[P[po]][2]] == 0))
                                     {V[K[P[po]][2]] = 1;
                                      A[po]=P[po];
                                      V[K[A[po-1]][1]]=0;
                                      if (A[po-1] <= N) A[po-1] = A[po-1]+N;
                                      else A[po-1] = A[po-1]-N;
                                      V[K[A[po-1]][1]]=1;
                                      Z[P[po]]=1;
                                      po++;
                                      P[po]=1;
                                     }
                                   else
                                     {if ((K[P[po]][2] == K[A[po-1]][2])&&(V[K[P[po]][1]] == 0))
                                        {V[K[P[po]][1]] = 1;
                                         A[po]=P[po]+N;
                                         Z[P[po]]=1;
                                         po++;
                                         P[po]=1;
                                        }
                                      else
                                        {if ((K[P[po]][2] == K[A[po-1]][1])&&(V[K[A[po-1]][2]] == 0)&&(V[K[P[po]][1]] == 0))
                                           {V[K[P[po]][1]] = 1;
                                            A[po]=P[po]+N;
                                            V[K[A[po-1]][1]]=0;
                                            if (A[po-1] <= N) A[po-1] = A[po-1]+N;
                                            else A[po-1] = A[po-1]-N;
                                            V[K[A[po-1]][1]]=1;
                                            Z[P[po]]=1;
                                            po++;
                                            P[po]=1;
                                           }
                                         else
                                           {if (P[po] == N)
                                              {po--;
                                               Z[P[po]]=0;
                                               if ((C[po] == 1)||(C[po] == 4)) V[K[A[po]][1]]=0;
                                               if ((C[po] == 3)||(C[po] == 4)||(C[po] == 5)) V[K[A[po]][2]]=0;
                                              }
                                            P[po]=P[po]+1;
                                           }
                                        }
                                     }
                                  }
                       }

                     if (po == suma+1)
                       {printf("\na packing of the sequence (");
                        for (i=1;i<il_p;i++) printf("%d,",T[i]+1);
                        printf("%d): ",T[il_p]+1);
                        l=0;
                        for (i=1;i<=il_p;i++)
                           {printf("___%d",K[A[l+1]][1]);
                            for (j=2;j<=T[i];j++) printf(",%d",K[A[l+j]][1]);
                            l=l+T[i];
                            printf(",%d",K[A[l]][2]);
                           }
                        fprintf(outcome,"\n\n(");
                        for (i=1;i<il_p;i++) fprintf(outcome,"%d,",T[i]+1);
                        fprintf(outcome,"%d):",T[il_p]+1);
                        l=0;
                        for (i=1;i<=il_p;i++)
                           {fprintf(outcome,"   %d",K[A[l+1]][1]);
                            for (j=2;j<=T[i];j++) fprintf(outcome,",%d",K[A[l+j]][1]);
                            l=l+T[i];
                            fprintf(outcome,",%d",K[A[l]][2]);
                           }

                        po=-1;
                       }

                }
             }


        if (po == 0)
          {printf("\nThe following sequence cannot be packed: (");
           for (i=1;i<il_p;i++) printf("%d,",T[i]+1);
           printf("%d).",T[il_p]+1);
           getch();
           fprintf(outcome,"\n\nThe following sequence cannot be packed: (");
           for (i=1;i<il_p;i++) fprintf(outcome,"%d,",T[i]+1);
           fprintf(outcome,"%d).",T[il_p]+1);
          }

//****************************************************************
//********** THE END OF SEARCHING OF A REALIZATION ***************
//****************************************************************
//****************************************************************

                       }
                    ostatni = 0;
                }

              else
                { suma = suma - T[il_p];
                  ostatni = T[il_p];
                  il_p--;
                 }
              } // the end of the loop while( il_p >= 0 )

            printf("\nThe end of the admissible sequences.");
//************* The end of the main function *********************
//****************************************************************

        fclose(outcome);

        getch();
        
        return 0;
}

